def _commitData(self):
    """Compute dependent fields and write data into object."""

    # Compute dependent fields.
    data = self.data
    for schema in self._schemas:
        for field_id, field in schema.items():
            if self.isDirty(field_id):
                #LOG("DataModel", TRACE, "Computing field '%s'" % (field_id,))
                field.computeDependantFields(self._schemas, data,
                                             context=self._context)

    # Call the adapters to store the data.
    for adapter in self._adapters:
        adapter.setData(data)

from Products.CPSSchemas.DataModel import DataModel
DataModel._commitData = _commitData
