## Script (Python) "getFolderObjectsInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=student=None
##title=
##
# $Id:getFolderObjectsInfo.py 486 2006-09-06 10:09:39Z joachim $
"""
return Info about the FolderObjects
"""
request = context.REQUEST

wf = context.portal_workflow
mtool = context.portal_membership
#path_info = request.get('PATH_INFO').split('/')

info = context.waeup_tool.getAccessInfo(context)
info['action'] = "%s" % context.absolute_url()
info['choosen_ids'] = request.get('ids',[])
info['doc'] = context.getContent()
items = []
for id, object in context.objectItems():
    row = {}
    row['id'] = id
    content = object.getContent()
    row['title'] = getattr(content,'LongTitle',None) or content.Title
    row['url'] = object.absolute_url()
    row['is_editable'] = mtool.checkPermission('Modify portal content', object)
    items.append(row)
items.sort(cmp=lambda x,y: cmp(x['id'].lower(), y['id'].lower()))
info['items'] = items
return info
