## Script (Python) "fixReturningSession"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=
##
# $Id: fixReturningSession.py 2456 2007-10-28 07:09:46Z henrik $
"""
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
import logging
logger = logging.getLogger('Skins.fixReturningSession')
from Products.AdvancedQuery import Eq, Between, Le,In
aq_students = context.students_catalog.evalAdvancedQuery

request = context.REQUEST
session = request.SESSION
response = request.RESPONSE
setheader = request.RESPONSE.setHeader
students = context.portal_url.getPortalObject().campus.students
#from string import Template
#def rwrite(s):
#    response.setHeader('Content-type','text/html; charset=ISO-8859-15')
#    response.write("%s<br>\n\r" % s)

#logger.info('')

query = Eq('review_state','returning') & In('session',('2006/2007','06','6'))
brains = aq_students(query)
total = len(brains)
logger.info('started editing %d students with session 06 in state returning' % total)
count = 0
commit_after = 100

for brain in brains:
    count += 1
    if count and not count % commit_after:
        context.waeup_tool.doCommit()
        logger.info("Committing %s transactions, total %s" % (commit_after,count))
    try:
        study_course_doc = getattr(getattr(students,brain.id),'study_course').getContent()
        study_course_doc.edit(mapping = { "current_session": '05',
                                          "current_level": ''})
        #rwrite('found %s , %s ,%s, %s' % (brain.id,
        #                                  study_course_doc.current_session,
        #                                  brain.matric_no,
        #                                  brain.name))
        logger.info("Session and level of %s (%s, %s, %s) changed from ('%s', '%s') to ('%s', '%s')" % (brain.id,
                                          brain.matric_no,
                                          brain.name,
                                          brain.review_state,
                                          brain.session,
                                          brain.level,
                                          study_course_doc.current_session,
                                          study_course_doc.current_level,
                                          ))
    except:
        #rwrite('>>>> not found %s study_course' % (brain.id))
        pass
logger.info('finished editing %d students with session 06 in state returning' % total)

return
