## Script (Python) "getAccoFolderInfo"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=student=None
##title=
##
# $Id: getAccoFolderInfo.py 2845 2007-12-03 21:14:20Z joachim $
"""
return Info about the Accommodation-Folder
"""
try:
    from Products.zdb import set_trace
except:
    def set_trace():
        pass
request = context.REQUEST

wf = context.portal_workflow
mtool = context.portal_membership
path_info = request.get('PATH_INFO').split('/')

info = {}
info['action'] = "%s" % context.absolute_url()
info['choosen_ids'] = request.get('ids',[])
items = []
is_editable = mtool.checkPermission('Modify portal content', context)
#is_editable = False
#halls = context.portal_catalog(portal_type='AccoHall')
for id,hall in context.objectItems():
    hall_doc = hall.getContent()
    row = {}
    row['id'] = id
    row['title'] = hall_doc.Title()
    row['sort_id'] = getattr(hall_doc,'sort_id',0)
    row['url'] = "%s/%s" % (context.absolute_url(),id)
    #fo = f.getObject()
    #row['is_editable'] = mtool.checkPermission('Modify portal content', fo)
    row['is_editable'] = is_editable
    items.append(row)
items.sort(cmp=lambda x,y: cmp( x['sort_id'],y['sort_id']))
info['items'] = items
return info

